Merge pull request #353 from RoldanLT/patch-4
[discourse_docker.git] / launcher
index 3bf9f8d60200596510e27a326d9f968e1d00caff..850041abe6580917cd3e94249e1f7e25731c8136 100755 (executable)
--- a/launcher
+++ b/launcher
@@ -1,20 +1,72 @@
 #!/bin/bash
 
+usage () {
+  echo "Usage: launcher COMMAND CONFIG [--skip-prereqs] [--docker-args STRING]"
+  echo "Commands:"
+  echo "    start:      Start/initialize a container"
+  echo "    stop:       Stop a running container"
+  echo "    restart:    Restart a container"
+  echo "    destroy:    Stop and remove a container"
+  echo "    enter:      Open a shell to run commands inside the container"
+  echo "    logs:       View the Docker logs for a container"
+  echo "    bootstrap:  Bootstrap a container for the config based on a template"
+  echo "    rebuild:    Rebuild a container (destroy old, bootstrap, start new)"
+  echo "    cleanup:    Remove all containers that have stopped for > 24 hours"
+  echo
+  echo "Options:"
+  echo "    --skip-prereqs             Don't check launcher prerequisites"
+  echo "    --docker-args              Extra arguments to pass when running docker"
+  echo "    --skip-mac-address         Don't assign a mac address"
+  exit 1
+}
+
 command=$1
 config=$2
-opt=$3
+user_args=""
+
+while [ ${#} -gt 0 ]; do
+  case "${1}" in
+  --debug)
+    DEBUG="1"
+    ;;
+  --skip-prereqs)
+    SKIP_PREREQS="1"
+    ;;
+  --skip-mac-address)
+    SKIP_MAC_ADDRESS="1"
+    ;;
+  --docker-args)
+    user_args="$2"
+    shift
+    ;;
+  esac
+
+  shift 1
+done
+
+# Docker doesn't like uppercase characters, spaces or special characters, catch it now before we build everything out and then find out
+re='[A-Z/ !@#$%^&*()+~`=]'
+if [[ $config =~ $re ]];
+  then
+    echo
+    echo "ERROR: Config name must not contain upper case characters, spaces or special characters. Correct config name and rerun $0."
+    echo
+    exit 1
+fi
 
 cd "$(dirname "$0")"
 
-docker_min_version='1.2.0'
-docker_rec_version='1.2.0'
+docker_min_version='1.8.0'
+docker_rec_version='1.8.0'
+git_min_version='1.8.0'
+git_rec_version='1.8.0'
 
 config_file=containers/"$config".yml
-cidfile=cids/"$config".cid
-cidbootstrap=cids/"$config"_boostrap.cid
+cidbootstrap=cids/"$config"_bootstrap.cid
 local_discourse=local_discourse
-image=samsaffron/discourse:1.0.5
+image=discourse/base:2.0.20170531
 docker_path=`which docker.io || which docker`
+git_path=`which git`
 
 if [ "${SUPERVISED}" = "true" ]; then
   restart_policy="--restart=no"
@@ -24,7 +76,9 @@ else
   attach_on_run="-d"
 fi
 
-if [ -x "$(which ip 2>/dev/null)" ]; then
+if [ -n "$DOCKER_HOST" ]; then
+  docker_ip=`sed -e 's/^tcp:\/\/\(.*\):.*$/\1/' <<< "$DOCKER_HOST"`
+elif [ -x "$(which ip 2>/dev/null)" ]; then
   docker_ip=`ip addr show docker0 | \
                   grep 'inet ' | \
                   awk '{ split($2,a,"/"); print a[1] }';`
@@ -36,26 +90,6 @@ else
                   awk -F: '{ print $3 }';`
 fi
 
-
-usage () {
-  echo "Usage: launcher COMMAND CONFIG [--skip-prereqs]"
-  echo "Commands:"
-  echo "    start:      Start/initialize a container"
-  echo "    stop:       Stop a running container"
-  echo "    restart:    Restart a container"
-  echo "    destroy:    Stop and remove a container"
-  echo "    enter:      Use nsenter to enter a container"
-  echo "    ssh:        Start a bash shell in a running container"
-  echo "    logs:       Docker logs for container"
-  echo "    mailtest:   Test the mail settings in a container"
-  echo "    bootstrap:  Bootstrap a container for the config based on a template"
-  echo "    rebuild:    Rebuild a container (destroy old, bootstrap, start new)"
-  echo
-  echo "Options:"
-  echo "    --skip-prereqs   Don't check prerequisites"
-  exit 1
-}
-
 compare_version() {
     declare -a ver_a
     declare -a ver_b
@@ -77,111 +111,97 @@ compare_version() {
     return 1  # They are equal
 }
 
-prereqs() {
 
-  # 1. docker daemon running?
-  test=`$docker_path info >/dev/null`
+install_docker() {
+  echo "Docker is not installed, you will need to install Docker in order to run Launcher"
+  echo "See https://docs.docker.com/installation/"
+  exit 1
+}
+
+check_prereqs() {
+
+  if [ -z $docker_path ]; then
+    install_docker
+  fi
 
+  # 1. docker daemon running?
+  # we send stderr to /dev/null cause we don't care about warnings,
+  # it usually complains about swap which does not matter
+  test=`$docker_path info 2> /dev/null`
   if [[ $? -ne 0 ]] ; then
     echo "Cannot connect to the docker daemon - verify it is running and you have access"
     exit 1
   fi
 
-  # 2. running aufs or btrfs
-  test=`$docker_path info 2> /dev/null | grep 'Driver: '`
-  if [[ "$test" =~ [aufs|btrfs] ]] ; then : ; else
-    echo "Your Docker installation is not using the recommended AuFS (union filesystem) and may be unstable."
-    echo "If you are unable to bootstrap / stop your image please report the issue at:"
-    echo "https://meta.discourse.org/t/discourse-docker-installation-without-aufs/15639"
+  # 2. running an approved storage driver?
+  if ! $docker_path info 2> /dev/null | egrep -q '^Storage Driver: (aufs|btrfs|zfs|overlay|overlay2)$'; then
+    echo "Your Docker installation is not using a supported storage driver.  If we were to proceed you may have a broken install."
+    echo "aufs is the recommended storage driver, although zfs/btrfs/overlay and overlay2 may work as well."
+    echo "Other storage drivers are known to be problematic."
+    echo "You can tell what filesystem you are using by running \"docker info\" and looking at the 'Storage Driver' line."
+    echo
+    echo "If you wish to continue anyway using your existing unsupported storage driver,"
+    echo "read the source code of launcher and figure out how to bypass this check."
+    exit 1
   fi
 
   # 3. running recommended docker version
   test=($($docker_path --version))  # Get docker version string
   test=${test[2]//,/}  # Get version alone and strip comma if exists
 
-  [[ "$test" =~ "0.12.0" ]] && echo "You are running a broken version of Docker, please upgrade ASAP. See: https://meta.discourse.org/t/the-installation-stopped-in-the-middle/16311/ for more details." && exit 1
-
-  # At least minimum version
+  # At least minimum docker version
   if compare_version "${docker_min_version}" "${test}"; then
     echo "ERROR: Docker version ${test} not supported, please upgrade to at least ${docker_min_version}, or recommended ${docker_rec_version}"
     exit 1
   fi
 
-  # Recommend best version
+  # Recommend newer docker version
   if compare_version "${docker_rec_version}" "${test}"; then
     echo "WARNING: Docker version ${test} deprecated, recommend upgrade to ${docker_rec_version} or newer."
   fi
 
-  # 4. able to attach stderr / out / tty
-  test=`$docker_path run -i --rm -a stdout -a stderr $image echo working`
-  if [[ "$test" =~ "working" ]] ; then : ; else
-    echo "Your Docker installation is not working correctly"
+  # 4. discourse docker image is downloaded
+  test=`$docker_path images | awk '{print $1 ":" $2 }' | grep "$image"`
+
+  if [ -z "$test" ]; then
+    echo
+    echo "WARNING: We are about to start downloading the Discourse base image"
+    echo "This process may take anywhere between a few minutes to an hour, depending on your network speed"
+    echo
+    echo "Please be patient"
     echo
-    echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
-    exit 1
   fi
-}
-
-if [ "$opt" != "--skip-prereqs" ] ; then
-  prereqs
-fi
 
-get_ssh_pub_key() {
-  local ${ssh_key_locations}
-  ssh_key_locations=(
-    ~/.ssh/id_ed25519.pub
-    ~/.ssh/id_ecdsa.pub
-    ~/.ssh/id_rsa.pub
-    ~/.ssh/id_dsa.pub
-    ~core/.ssh/authorized_keys
-  )
-
-  local $keyfile
-  for keyfile in "${ssh_key_locations[@]}"; do
-    if [[ -e ${keyfile} ]] ; then
-      ssh_pub_key="$(cat ${keyfile})"
-      return 0
-    fi
-  done
+  # 5. running recommended git version
+  test=($($git_path --version))  # Get git version string
+  test=${test[2]//,/}  # Get version alone and strip comma if exists
 
-  if tty -s ; then
-    echo "This user has no SSH key, but a SSH key is required to access the Discourse Docker container."
-    read -p "Generate a SSH key? (Y/n) " -n 1 -r
-    if [[ $REPLY =~ ^[Nn]$ ]] ; then
-      echo
-      echo WARNING: You may not be able to log in to your container.
-      echo
-    else
-      echo
-      echo Generating SSH key
-      mkdir -p ~/.ssh && ssh-keygen -f ~/.ssh/id_rsa -t rsa -N ''
-      echo
-      ssh_pub_key="$(cat ~/.ssh/id_rsa.pub)"
-      return 0
-    fi
+  # At least minimum version
+  if compare_version "${git_min_version}" "${test}"; then
+    echo "ERROR: Git version ${test} not supported, please upgrade to at least ${git_min_version}, or recommended ${git_rec_version}"
+    exit 1
   fi
 
-  return 1
-}
-
+  # Recommend best version
+  if compare_version "${git_rec_version}" "${test}"; then
+    echo "WARNING: Git version ${test} deprecated, recommend upgrade to ${git_rec_version} or newer."
+  fi
 
-install_docker() {
+  # 6. able to attach stderr / out / tty
+  test=`$docker_path run $user_args -i --rm -a stdout -a stderr $image echo working`
+  if [[ "$test" =~ "working" ]] ; then : ; else
+    echo "Your Docker installation is not working correctly"
+    echo
+    echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
+    exit 1
+  fi
 
-  echo "Docker is not installed, make sure you are running on the 3.8 kernel"
-  echo "The best supported Docker release is Ubuntu 12.04.03 for it run the following"
-  echo
-  echo "sudo apt-get update"
-  echo "sudo apt-get install linux-image-generic-lts-raring linux-headers-generic-lts-raring"
-  echo "sudo reboot"
-  echo
+}
 
-  echo "sudo sh -c \"wget -qO- https://get.docker.io/gpg | apt-key add -\""
-  echo "sudo sh -c \"echo deb http://get.docker.io/ubuntu docker main > /etc/apt/sources.list.d/docker.list\""
-  echo "sudo apt-get update"
-  echo "sudo apt-get install lxc-docker"
 
-  exit 1
-}
+if [ -z "$SKIP_PREREQS" ] ; then
+  check_prereqs
+fi
 
 host_run() {
   read -r -d '' env_ruby << 'RUBY'
@@ -201,7 +221,7 @@ host_run() {
   end
 RUBY
 
-  host_run=`cat $config_file | $docker_path run --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
+  host_run=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
 
   while [ "$host_run" ] ; do
     iter=${host_run%%--SEP--*}
@@ -215,27 +235,45 @@ RUBY
 
 
 set_volumes() {
-  volumes=`cat $config_file | $docker_path run --rm -i -a stdout -a stdin $image ruby -e \
+  volumes=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
         "require 'yaml'; puts YAML.load(STDIN.readlines.join)['volumes'].map{|v| '-v ' << v['volume']['host'] << ':' << v['volume']['guest'] << ' '}.join"`
 }
 
 set_links() {
-    links=`cat $config_file | $docker_path run --rm -i -a stdout -a stdin $image ruby -e \
+    links=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
         "require 'yaml'; puts YAML.load(STDIN.readlines.join)['links'].map{|l| '--link ' << l['link']['name'] << ':' << l['link']['alias'] << ' '}.join"`
 }
 
-set_template_info() {
-
-    templates=`cat $config_file | $docker_path run --rm -i -a stdin -a stdout $image ruby -e \
+find_templates() {
+    local templates=`cat $1 | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
       "require 'yaml'; puts YAML.load(STDIN.readlines.join)['templates']"`
 
+    local arrTemplates=${templates// / }
+
+    if [ ! -z "$templates" ]; then
+      for template in "${arrTemplates[@]}"
+      do
+        local nested_templates=$(find_templates $template)
+
+        if [ ! -z "$nested_templates" ]; then
+          templates="$templates $nested_templates"
+        fi
+      done
+
+      echo $templates
+    else
+      echo ""
+    fi
+}
+
+set_template_info() {
+    templates=$(find_templates $config_file)
 
     arrTemplates=(${templates// / })
     config_data=$(cat $config_file)
 
     input="hack: true"
 
-
     for template in "${arrTemplates[@]}"
     do
       [ ! -z $template ] && {
@@ -267,7 +305,7 @@ set_template_info() {
     puts env.map{|k,v| "-e\n#{k}=#{v}" }.join("\n")
 RUBY
 
-    raw=`exec echo "$input" | $docker_path run --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
+    raw=`exec echo "$input" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
 
     env=()
     ok=1
@@ -281,115 +319,218 @@ RUBY
 
     if [ "$ok" -ne 1 ]; then
       echo "${env[@]}"
-      echo "YAML syntax error. Please check your /var/docker/containers/*.yml config files."
+      echo "YAML syntax error. Please check your containers/*.yml config files."
+      exit 1
+    fi
+
+    read -r -d '' labels_ruby << 'RUBY'
+    require 'yaml'
+
+    input=STDIN.readlines.join
+    # default to UTF-8 for the dbs sake
+    labels = {}
+    input.split('_FILE_SEPERATOR_').each do |yml|
+       yml.strip!
+       begin
+         labels.merge!(YAML.load(yml)['labels'] || {})
+       rescue Psych::SyntaxError => e
+        puts e
+        puts "*ERROR."
+       rescue => e
+        puts yml
+        p e
+       end
+    end
+    puts labels.map{|k,v| "-l\n#{k}=#{v}" }.join("\n")
+RUBY
+
+    raw=`exec echo "$input" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$labels_ruby"`
+
+    labels=()
+    ok=1
+    while read i; do
+      if [ "$i" == "*ERROR." ]; then
+        ok=0
+      elif [ -n "$i" ]; then
+        labels[${#labels[@]}]=$i
+      fi
+    done <<< "$raw"
+
+    if [ "$ok" -ne 1 ]; then
+      echo "${labels[@]}"
+      echo "YAML syntax error. Please check your containers/*.yml config files."
       exit 1
     fi
-    echo "Calculated ENV: ${env[@]}"
 }
 
-[ -z $docker_path ] && {
+if [ -z $docker_path ]; then
   install_docker
-}
+fi
 
+[ "$command" == "cleanup" ] && {
+  echo
+  echo "The following command will"
+  echo "- Delete all docker images for old containers"
+  echo "- Delete all stopped and orphan containers"
+  echo
+  read -p "Are you sure (Y/n): " -n 1 -r && echo
+  if [[ $REPLY =~ ^[Yy]$ || ! $REPLY ]]
+    then
+      space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
+      echo "Starting Cleanup (bytes free $space)"
 
-[ $# -lt 2 ] && {
-  usage
+      STATE_DIR=./.gc-state scripts/docker-gc
+
+      space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
+      echo "Finished Cleanup (bytes free $space)"
+
+    else
+      exit 1
+  fi
+  exit 0
 }
 
-if [ ! -e $config_file ]
-  then
+if [ -z "$command" -a -z "$config" ]; then
+  usage
+fi
+
+if [ ! "$command" == "setup" ]; then
+  if [[ ! -e $config_file ]]; then
     echo "Config file was not found, ensure $config_file exists"
-    echo ""
+    echo
     echo "Available configs ( `cd containers && ls -dm *.yml | tr -s '\n' ' ' | awk '{ gsub(/\.yml/, ""); print }'`)"
     exit 1
+  fi
 fi
 
-
 docker_version=($($docker_path --version))
 docker_version=${test[2]//,/}
+restart_policy=${restart_policy:---restart=always}
 
-if compare_version "1.2.0" "$docker_version"; then
-  echo "We recommend you upgrade docker, the version you are running has no restart policies, on reboot your container may not start up"
-  restart_policy=""
-else
-  restart_policy=${restart_policy:---restart=always}
-fi
+set_existing_container(){
+  existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
+}
 
+run_stop() {
 
-run_mailtest(){
-  if [ ! -e $config_file ]; then
-    echo "Config does not exist: $config_file" >&2
-    exit 1
-  fi
-  exec scripts/mailtest $config_file
-}
+  set_existing_container
 
-run_stop(){
-  if [ ! -e $cidfile ]
+  if [ ! -z $existing ]
      then
-       echo "No cid found"
-       exit 1
+       (
+        set -x
+        $docker_path stop -t 10 $config
+       )
      else
-       $docker_path stop -t 10 `cat $cidfile`
+       echo "$config was not started !"
+       exit 1
   fi
 }
 
-run_start(){
+set_run_image() {
+  run_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
+    "require 'yaml'; puts YAML.load(STDIN.readlines.join)['run_image']"`
 
-  host_run
+  if [ -z "$run_image" ]; then
+    run_image="$local_discourse/$config"
+  fi
+}
+
+set_boot_command() {
+  boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
+    "require 'yaml'; puts YAML.load(STDIN.readlines.join)['boot_command']"`
+
+  if [ -z "$boot_command" ]; then
+
+    no_boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
+      "require 'yaml'; puts YAML.load(STDIN.readlines.join)['no_boot_command']"`
+
+    if [ -z "$no_boot_command" ]; then
+      boot_command="/sbin/boot"
+    fi
+  fi
+}
 
-  if [ ! -e $cidfile ]
+run_start() {
+
+   existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
+   echo $existing
+   if [ ! -z $existing ]
+   then
+     echo "Nothing to do, your container has already started!"
+     exit 0
+   fi
+
+   existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
+   if [ ! -z $existing ]
+   then
+     echo "starting up existing container"
+     (
+       set -x
+       $docker_path start $config
+     )
+     exit 0
+   fi
+
+   host_run
+
+   ports=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
+         "require 'yaml'; puts YAML.load(STDIN.readlines.join)['expose'].map{|p| \"-p #{p}\"}.join(' ')"`
+
+   docker_args=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
+          "require 'yaml'; puts YAML.load(STDIN.readlines.join)['docker_args']"`
+
+   set_template_info
+   set_volumes
+   set_links
+   set_run_image
+   set_boot_command
+
+   # get hostname and settings from container configuration
+   for envar in "${env[@]}"
+   do
+     if [[ $envar == DOCKER_USE_HOSTNAME* ]] || [[ $envar == DISCOURSE_HOSTNAME* ]]
      then
-       echo "No cid found, creating a new container"
-       ports=`cat $config_file | $docker_path run --rm -i -a stdout -a stdin $image ruby -e \
-              "require 'yaml'; puts YAML.load(STDIN.readlines.join)['expose'].map{|p| '-p ' << p.to_s << ' '}.join"`
-
-       set_template_info
-       set_volumes
-       set_links
-
-       existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep "$config$" | awk '{ print $1 }'`
-       if [ ! -z $existing ]
-       then
-         echo "Found an existing container by its name, recovering cidfile, please rerun"
-         echo $existing > $cidfile
-         exit 1
-       fi
-
-       $docker_path run $links $attach_on_run $restart_policy "${env[@]}" -h "`hostname`-$config" -e DOCKER_HOST_IP=$docker_ip --name $config -t --cidfile $cidfile $ports \
-                  $volumes $local_discourse/$config /sbin/boot
-
-       exit 0
+       # use as environment variable
+       eval $envar
+     fi
+   done
+
+   (
+     hostname=`hostname -s`
+     # overwrite hostname
+     if [ "$DOCKER_USE_HOSTNAME" = "true" ]
+     then
+       hostname=$DISCOURSE_HOSTNAME
      else
-       cid=`cat $cidfile`
-
-       if [ -z $cid ]
-       then
-         echo "Detected empty cid file, deleting, please re-run"
-         rm $cidfile
-         exit 1
-       fi
-
-       found=`$docker_path ps -q -a --no-trunc | grep $cid`
-       if [ -z $found ]
-       then
-         echo "Invalid cid file, deleting, please re-run"
-         rm $cidfile
-         exit 1
-       fi
-
-       echo "cid found, ensuring container is started"
-       $docker_path start $attach_on_start `cat $cidfile`
-       exit 0
-  fi
+       hostname=$hostname-$config
+     fi
+
+     # we got to normalize so we only have allowed strings, this is more comprehensive but lets see how bash does first
+     # hostname=`$docker_path run $user_args --rm $image ruby -e 'print ARGV[0].gsub(/[^a-zA-Z-]/, "-")' $hostname`
+     # docker added more hostname rules
+     hostname=${hostname//_/-}
+
+
+     if [ -z "$SKIP_MAC_ADDRESS" ] ; then
+      mac_address="--mac-address $($docker_path run $user_args -i --rm -a stdout -a stderr $image /bin/sh -c "echo $hostname | md5sum | sed 's/^\(..\)\(..\)\(..\)\(..\)\(..\).*$/02:\1:\2:\3:\4:\5/'")"
+     fi
+
+     set -x
+     $docker_path run $links $attach_on_run $restart_policy "${env[@]}" "${labels[@]}" -h "$hostname" \
+        -e DOCKER_HOST_IP="$docker_ip" --name $config -t $ports $volumes $mac_address $docker_args $user_args \
+        $run_image $boot_command
+
+   )
+   exit 0
 
 }
 
-run_bootstrap(){
 
-  host_run
+run_bootstrap() {
 
-  get_ssh_pub_key
+  # I got no frigging clue what this does, ask Sam Saffron. It RUNS STUFF ON THE HOST I GUESS?
+  host_run
 
   # Is the image available?
   # If not, pull it here so the user is aware what's happening.
@@ -397,10 +538,10 @@ run_bootstrap(){
 
   set_template_info
 
-  base_image=`cat $config_file | $docker_path run --rm -i -a stdin -a stdout $image ruby -e \
+  base_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
     "require 'yaml'; puts YAML.load(STDIN.readlines.join)['base_image']"`
 
-  update_pups=`cat $config_file | $docker_path run --rm -i -a stdin -a stdout $image ruby -e \
+  update_pups=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
     "require 'yaml'; puts YAML.load(STDIN.readlines.join)['update_pups']"`
 
   if [[ ! X"" = X"$base_image" ]]; then
@@ -420,13 +561,31 @@ run_bootstrap(){
 
   echo $run_command
 
-  env=("${env[@]}" "-e" "SSH_PUB_KEY=$ssh_pub_key")
+  unset ERR
+  (exec echo "$input" | $docker_path run $user_args $links "${env[@]}" -e DOCKER_HOST_IP="$docker_ip" --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
+    /bin/bash -c "$run_command") || ERR=$?
+
+  unset FAILED
+  # magic exit code that indicates a retry
+  if [[ "$ERR" == 77 ]]; then
+    $docker_path rm `cat $cidbootstrap`
+    rm $cidbootstrap
+    exit 77
+  elif [[ "$ERR" > 0 ]]; then
+    FAILED=TRUE
+  fi
 
-  (exec echo "$input" | $docker_path run $links "${env[@]}" -e DOCKER_HOST_IP=$docker_ip --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
-     /bin/bash -c "$run_command") \
-     || ($docker_path rm `cat $cidbootstrap` && rm $cidbootstrap)
+  if [[ $FAILED = "TRUE" ]]; then
+    if [[ ! -z "$DEBUG" ]]; then
+      $docker_path commit `cat $cidbootstrap` $local_discourse/$config-debug || echo 'FAILED TO COMMIT'
+      echo "** DEBUG ** Maintaining image for diagnostics $local_discourse/$config-debug"
+    fi
 
-  [ ! -e $cidbootstrap ] && echo "FAILED TO BOOTSTRAP" && exit 1
+    $docker_path rm `cat $cidbootstrap`
+    rm $cidbootstrap
+    echo "** FAILED TO BOOTSTRAP ** please scroll up and look for earlier error messages, there may be more than one"
+    exit 1
+  fi
 
   sleep 5
 
@@ -434,6 +593,8 @@ run_bootstrap(){
   $docker_path rm `cat $cidbootstrap` && rm $cidbootstrap
 }
 
+
+
 case "$command" in
   bootstrap)
       run_bootstrap
@@ -441,51 +602,8 @@ case "$command" in
       exit 0
       ;;
 
-  mailtest)
-      run_mailtest
-      exit 0
-      ;;
-
   enter)
-
-      if [ ! -e $cidfile ]
-         then
-           echo "No cid found"
-           exit 1
-      fi
-
-      if [ ! $UID -eq 0 ] ;
-        then
-        echo "enter command must run as root, will attempt to sudo"
-        echo
-      fi
-
-      if [ ! -e bin/nsenter ]
-        then
-          echo "Downloading nsenter"
-          $docker_path pull samsaffron/nsenter
-          ($docker_path run --rm samsaffron/nsenter cat /nsenter > bin/nsenter1) || exit 1
-          cp bin/nsenter1 bin/nsenter
-          chmod +x bin/nsenter
-      fi
-
-      PID=$($docker_path inspect --format {{.State.Pid}} `cat $cidfile`)
-      SHELL=/bin/bash sudo -E bin/nsenter --target $PID --mount --uts --ipc --net --pid
-
-      exit 0;
-      ;;
-
-  ssh)
-      if [ ! -e $cidfile ]
-         then
-           echo "No cid found"
-           exit 1
-         else
-           cid="`cat $cidfile`"
-           address="`$docker_path port $cid 22`"
-           split=(${address//:/ })
-           exec ssh -o StrictHostKeyChecking=no root@${split[0]} -p ${split[1]}
-      fi
+      exec $docker_path exec -it $config /bin/bash --login
       ;;
 
   stop)
@@ -495,14 +613,8 @@ case "$command" in
 
   logs)
 
-      if [ ! -e $cidfile ]
-         then
-           echo "No cid found"
-           exit 1
-         else
-           $docker_path logs `cat $cidfile`
-           exit 0
-      fi
+      $docker_path logs $config
+      exit 0
       ;;
 
   restart)
@@ -518,20 +630,56 @@ case "$command" in
 
   rebuild)
       if [ "$(git symbolic-ref --short HEAD)" == "master" ]; then
-        echo "Updating discourse docker"
-        git pull || (echo 'failed to update' && exit 1)
+        echo "Ensuring launcher is up to date"
+
+        git remote update
+
+        LOCAL=$(git rev-parse @)
+        REMOTE=$(git rev-parse @{u})
+        BASE=$(git merge-base @ @{u})
+
+        if [ $LOCAL = $REMOTE ]; then
+          echo "Launcher is up-to-date"
+
+        elif [ $LOCAL = $BASE ]; then
+          echo "Updating Launcher"
+          git pull || (echo 'failed to update' && exit 1)
+
+          for (( i=${#BASH_ARGV[@]}-1,j=0; i>=0,j<${#BASH_ARGV[@]}; i--,j++ ))
+          do
+            args[$j]=${BASH_ARGV[$i]}
+          done
+          exec /bin/bash $0 "${args[@]}" # $@ is empty, because of shift at the beginning. Use BASH_ARGV instead.
+
+        elif [ $REMOTE = $BASE ]; then
+          echo "Your version of Launcher is ahead of origin"
+
+        else
+          echo "Launcher has diverged source, this is only expected in Dev mode"
+        fi
+
       fi
-      if [ -e $cidfile ]
+
+      set_existing_container
+
+      if [ ! -z $existing ]
         then
           echo "Stopping old container"
-          $docker_path stop -t 10 `cat $cidfile`
+          (
+            set -x
+            $docker_path stop -t 10 $config
+          )
       fi
 
       run_bootstrap
 
-      if [ -e $cidfile ]
+      if [ ! -z $existing ]
         then
-          $docker_path rm `cat $cidfile` && rm $cidfile
+          echo "Removing old container"
+          (
+            set -x
+            $docker_path rm $config
+          )
       fi
 
       run_start
@@ -540,16 +688,8 @@ case "$command" in
 
 
   destroy)
-      if [ -e $cidfile ]
-        then
-          echo "destroying container $cidfile"
-          $docker_path stop -t 10 `cat $cidfile`
-          $docker_path rm `cat $cidfile` && rm $cidfile
-          exit 0
-        else
-          echo "nothing to destroy cidfile does not exist"
-          exit 1
-      fi
+      (set -x; $docker_path stop -t 10 $config && $docker_path rm $config) || (echo "$config was not found" && exit 0)
+      exit 0
       ;;
 esac